Page tree

Versions Compared

Key

  • This line was added.
  • This line was removed.
  • Formatting was changed.

...

Table of Content Zone
locationtop
stylesquare

UNIX-like OS or Microsoft Windows

  • UNIX-like operating system (Linux, HP/UX, Mac OSX, etc.) : Many distributions of Linux/Unix come with some of the dependencies below pre-installed or easily installed via updates.  You should consult your particular distribution's documentation or local system administrators to determine what is already available.
  • Microsoft Windows:  While DSpace can be run on Windows servers, most institutions tend to run it on a UNIX-like operating system.


Java JDK 11 (OpenJDK or Oracle JDK)

Info
titleMake sure to install the JDK and not just the JRE

 At this time, DSpace requires the full JDK (Java Development Kit) be installed, rather than just the JRE (Java Runtime Environment).  So, please be sure that you are installing the full JDK and not just the JRE.


Note
titleOnly JDK11 is fully supported

Older versions of Java are unsupported. This includes JDK v7-10.

Newer versions of Java may work (e.g. JDK v12-16), but we do not recommend running them in Production.  We highly recommend running only Java LTS (Long Term Support) releases in Production, as non-LTS releases may not receive ongoing security fixes. As of this DSpace release, JDK11 is the most recent Java LTS release, with the next one (JDK17) being due sometime around September 2021.  As soon as the next Java LTS release is available, we will analyze it for compatibility with this release of DSpace.  For more information on Java releases, see the Java roadmaps for Oracle and/or OpenJDK.


Apache Maven 3.3.x or above (Java build tool)

Maven is necessary in the first stage of the build process to assemble the installation package for your DSpace instance. It gives you the flexibility to customize DSpace using the existing Maven projects found in the [dspace-source]/dspace/modules directory or by adding in your own Maven project to build the installation package for DSpace, and apply any custom interface "overlay" changes.

Maven can be downloaded from http://maven.apache.org/download.html

Configuring a Maven Proxy

You can configure a proxy to use for some or all of your HTTP requests in Maven. The username and password are only required if your proxy requires basic authentication (note that later releases may support storing your passwords in a secured keystore‚ in the meantime, please ensure your settings.xml file (usually ${user.home}/.m2/settings.xml) is secured with permissions appropriate for your operating system).

Example:

Code Block
<settings>
  .
  .
  <proxies>
   <proxy>
      <active>true</active>
      <protocol>http</protocol>
      <host>proxy.somewhere.com</host>
      <port>8080</port>
      <username>proxyuser</username>
      <password>somepassword</password>
      <nonProxyHosts>www.google.com|*.somewhere.com</nonProxyHosts>
    </proxy>
  </proxies>
  .
  .
</settings>


Apache Ant 1.8 or later (Java build tool)

Apache Ant is required for the second stage of the build process (deploying/installing the application). First, Maven is used to construct the installer ([dspace-source]/dspace/target/dspace-installer), after which Ant is used to install/deploy DSpace to the installation directory.

Ant can be downloaded from the following location: http://ant.apache.org

Relational Database (PostgreSQL or Oracle)

PostgreSQL v11 (with pgcrypto installed)
Note
titlePostgreSQL v9.4 to v11 will likely work, but earlier versions are less well tested.

Active development/testing on DSpace 7 has occurred on PostgreSQL v11.  However, it is likely that the backend would also function on PostgreSQL v9.4 - v10.  At this time we have not performed sufficient testing on these earlier versions to add them to the prerequisites listing.

DSpace 7 will definitely not function on versions below 9.4 as DSpace requires installing and running the pgcrypto extension (see below) v1.1, which was not available until PostgreSQL v9.4.

  • PostgreSQL can be downloaded from http://www.postgresql.org/.  It is also provided via many operating system package managers
  • Install the pgcrypto extension.  It will also need to be enabled on your DSpace Database (see Installation instructions below for more info). The pgcrypto extension allows DSpace to create UUIDs (universally unique identifiers) for all objects in DSpace, which means that (internal) object identifiers are now globally unique and no longer tied to database sequences.
    • On most Linux operating systems (Ubuntu, Debian, RedHat), this extension is provided in the "postgresql-contrib" package in your package manager. So, ensure you've installed "postgresql-contrib".
    • On Windows, this extension should be provided automatically by the installer (check your "[PostgreSQL]/share/extension" folder for files starting with "pgcrypto")
  • Unicode (specifically UTF-8) support must be enabled (but this is enabled by default).
  • Once installed, you need to enable TCP/IP connections (DSpace uses JDBC):
    • In postgresql.conf: uncomment the line starting: listen_addresses = 'localhost'.  This is the default, in recent PostgreSQL releases, but you should at least check it.
    • Then tighten up security a bit by editing pg_hba.conf and adding this line:

      Code Block
      host dspace dspace 127.0.0.1 255.255.255.255 md5

      This should appear before any lines matching all databases, because the first matching rule governs.

    • Then restart PostgreSQL.
Oracle 10g or later
  • Details on acquiring Oracle can be downloaded from the following location: http://www.oracle.com/database/. You will need to create a database for DSpace. Make sure that the character set is one of the Unicode character sets. DSpace uses UTF-8 natively, and it is suggested that the Oracle database use the same character set. You will also need to create a user account for DSpace (e.g. dspace) and ensure that it has permissions to add and remove tables in the database. Refer to the Quick Installation for more details.
    • NOTE: If the database server is not on the same machine as DSpace, you must install the Oracle client to the DSpace server and point tnsnames.ora and listener.ora files to the database the Oracle server.

Apache Solr 7.2.1 or later (full-text index/search service)

Solr can be obtained at the Apache Software Foundation site for Lucene and Solr.  You may wish to read portions of the quick-start tutorial to make yourself familiar with Solr's layout and operation.  Unpack a Solr .tgz or .zip archive in a place where you keep software that is not handled by your operating system's package management tools, and arrange to have it running whenever DSpace is running.  You should ensure that Solr's index directories will have plenty of room to grow.  You should also ensure that port 8983 is not in use by something else, or configure Solr to use a different port.

If you are looking for a good place to put Solr, consider /opt or /usr/local.  You can simply unpack Solr in one place and use it.  Or you can configure Solr to keep its indexes elsewhere, if you need to – see the Solr documentation for how to do this.

It is not necessary to dedicate a Solr instance to DSpace, if you already have one and want to use it.  Simply copy DSpace's cores to a place where they will be discovered by Solr.  See below.

Servlet Engine (Apache Tomcat 8.5 or later, Jetty, Caucho Resin or equivalent)

  • Apache Tomcat 8.5 or later. Tomcat can be downloaded from the following location: http://tomcat.apache.org.  
    • The Tomcat owner (i.e. the user that Tomcat runs as) must have read/write access to the DSpace installation directory (i.e. [dspace])There are a few common ways this may be achieved:
      • One option is to specifically give the Tomcat user (often named "tomcat") ownership of the [dspace] directories, for example:

        Code Block
        # Change [dspace] and all subfolders to be owned by "tomcat"
        chown -R tomcat:tomcat [dspace]


      • Another option is to have Tomcat itself run as a new user named "dspace" (see installation instructions below).  Some operating systems make modifying the Tomcat "run as" user easily modifiable via an environment variable named TOMCAT_USER.  This option may be more desirable if you have multiple Tomcat instances running, and you do not want all of them to run under the same Tomcat owner.
    • You need to ensure that Tomcat has a) enough memory to run DSpace and b) uses UTF-8 as its default file encoding for international character support. So ensure in your startup scripts (etc) that the following environment variable is set: JAVA_OPTS="-Xmx512M -Xms64M -Dfile.encoding=UTF-8"
    • Modifications in [tomcat]/conf/server.xml : You also need to alter Tomcat's default configuration to support searching and browsing of multi-byte UTF-8 correctly. You need to add a configuration option to the <Connector> element in [tomcat]/config/server.xml: URIEncoding="UTF-8" e.g. if you're using the default Tomcat config, it should read:

      Code Block
      languagehtml/xml
      <!-- Define a non-SSL HTTP/1.1 Connector on port 8080 -->
      <Connector port="8080"
                    minSpareThreads="25"
                    enableLookups="false"
                    redirectPort="8443"
                    connectionTimeout="20000"
                    disableUploadTimeout="true"
                    URIEncoding="UTF-8"/>
      

      You may change the port from 8080 by editing it in the file above, and by setting the variable CONNECTOR_PORT in server.xml.  You should set the URIEncoding even if you are running Tomcat behind a proxy (Apache HTTPD, Nginx, etc.) via AJP.

  • Jetty or Caucho Resin DSpace will also run on an equivalent servlet Engine, such as Jetty (https://www.eclipse.org/jetty/) or Caucho Resin (http://www.caucho.com/). If you choose to use a different servlet container, please ensure that it supports Servlet Spec 3.1 (or above).
    • Jetty and Resin are configured for correct handling of UTF-8 by default.
MaxMind's GeoLite Database (free version)

(Optional) IP to City Database for Location-based Statistics

Optionally, if you wish to record the geographic locations of clients in DSpace usage statistics records, you will need to install and maintain (and regularly update) one of the following:

.
  •  (in MMDB format)
    • NOTE: Installing MaxMind GeoLite2 is free.  However, you must sign up for a (free) MaxMind account in order to obtain a license key to use the GeoLite2 database.
    • You may download GeoLite2 directly from MaxMind, or many Linux distributions provide the geoipupdate tool directly via their package manager.  You will still need to configure your license key prior to usage.
    • Once the "GeoLite2-City.mmdb" database file is installed on your system,  you will need to configure its location as the value of usage-statistics.dbfile in your local.cfg configuration file
    • See the "Managing the
    GeoLite
    • City Database File" section of SOLR Statistics for more information about using a City Database with DSpace.
  • Or, you can alternatively use/install DB-IP's City Lite database (in MMDB format)
    • This database is also free to use, but does not require an account to download.
    • Once the "dbip-city-lite.mmdb" database file is installed on your system,  you will need to configure its location as the value of usage-statistics.dbfile in your local.cfg configuration file
    • See the "Managing the City Database File" section of SOLR Statistics for more information about using
    GeoLite2
    • a City Database with DSpace.

Git (code version control)

Currently, there is a known bug in DSpace where a third-party Maven Module expects git to be available (in order to support the ./dspace version commandline tool).  We are working on a solution within this ticket: 

Jira
serverDuraSpace JIRA
serverIdc815ca92-fd23-34c2-8fe3-956808caf8c5
keyDS-3418

For the time being, you can work around this problem by installing Git locally: https://git-scm.com/downloads

...